public class Stability {

    public static void main(String[] args){
	stabilityWithMillerTest();
    }
    
    protected static void stabilityWithMillerTest(){
	// example (vi) from Miller's paper
	
	double[][] poly;
	double[] value, omega;
	double maxOmegaR, zeroOmegaR;
	boolean instabilityFound;
	
	omega = new double[2];
	
	double beta;
	
	for (double A = -2.0; A <= 2.0; A += 0.01){
	    for (double B = -2.0; B <= 2.0; B += 0.01){
		for (double C = 1.3; C <= 2.0; C += 10.01){
		    instabilityFound = false;
		    
		    poly = new double[3][2];
		    poly[0][Complex.RE] = A; poly[1][Complex.RE] = B; poly[2][Complex.RE] = C;
		    
		    if (!Miller.vonNeumann(poly)){ instabilityFound = true; }
		    
		    
		    System.out.println(A + " " + B + " " + C + " " + (instabilityFound ? "1" : "0") + " " +
				       (exactStabilityTest(A, B, C) ? "0" : "1")
				       );
		}
	    }
	}
	
    }

    protected static boolean exactStabilityTest(double A, double B, double C){
	return
	    ( (((C - A)*(C + A) > 0) && ((B - A - C)*(B + A + C) <= 0)) ||
	      ((C - A == 0) && ((B - 2.0*A)*(B + 2.0*A) <= 0)) ||
	      ((C + A == 0) && (B == 0)) );
    }
    


}
